﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;

namespace TreeGridSample.Controllers
{
    public class TreeGridController : Controller
    {
        //
        // GET: /TreeGrid/

        public ActionResult Sample() {
            return View();
        }
        public ActionResult Index()
        {
            var DataSource = TreeGridDefaultData.GetData();
            ViewBag.datasource = DataSource;
            ViewBag.resource = ResourceList.GetResources();
            return View();
        }

        public class Resource
        {
            public int ResourceId { get; set; }
            public string ResourceName { get; set; }

        }

        //...
        public class ResourceList
        {
            public static List<Resource> GetResources()
            {
                List<Resource> ResourceCollection = new List<Resource>();
                ResourceCollection.Add(new Resource() { ResourceId = 1, ResourceName = "Project Manager" });
                ResourceCollection.Add(new Resource() { ResourceId = 2, ResourceName = "Software Analyst" });
                ResourceCollection.Add(new Resource() { ResourceId = 3, ResourceName = "Developer" });
                ResourceCollection.Add(new Resource() { ResourceId = 4, ResourceName = "Testing Engineer" });
                return ResourceCollection;
            }

        }

        public class DefaultData
        {
            public string StartDate { get; set; }
            public int Id { get; set; }
            public string Name { get; set; }
            public int Duration { get; set; }
            public int PercentDone { get; set; }
            public List<object> ResourceId { get; set; }
            public List<DefaultData> Children { get; set; }
        }

        public class TreeGridDefaultData
        {
            public static List<DefaultData> GetData()
            {
                List<DefaultData> list = new List<DefaultData>();
                list.Add(new DefaultData()
                {
                    Id = 1,
                    Name = "Parent Task 1",
                    StartDate = "02/23/2014",
                    Duration = 5,
                    PercentDone = 40,
                    Children = (new List<DefaultData>()
                    {
                        new DefaultData()
                        {
                            Id = 2,
                            Name = "Child Task 1",
                            StartDate = "02/23/2014",
                            Duration = 3,
                            PercentDone = 40,                                   
                            ResourceId=new List<object>(){1,2},
                        },
                        new DefaultData()
                        {
                            Id = 12,
                            Name = "Child Task 2",
                            StartDate = "02/26/2014",
                            Duration = 3,
                            PercentDone = 40,
                            ResourceId=new List<object>(){4}
                        },
                        new DefaultData()
                        {
                            Id = 13,
                            Name = "Child Task 3",
                            StartDate = "02/23/2014",
                            Duration = 0,
                            PercentDone = 40,
                            ResourceId=new List<object>(){2}
                        }
                    })
                });
                list.Add(new DefaultData()
                {
                    Id = 1,
                    Name = "Parent Task 2",
                    StartDate = "02/23/2014",
                    Duration = 5,
                    PercentDone = 40,
                    Children = (new List<DefaultData>()
                    {
                        new DefaultData()
                        {
                            Id = 2,
                            Name = "Child Task 1",
                            StartDate = "02/23/2014",
                            Duration = 3,
                            PercentDone = 40,                                   
                            ResourceId=new List<object>(){1,2},
                        },
                        new DefaultData()
                        {
                            Id = 12,
                            Name = "Child Task 2",
                            StartDate = "02/26/2014",
                            Duration = 3,
                            PercentDone = 40,
                            ResourceId=new List<object>(){4}
                        },
                        new DefaultData()
                        {
                            Id = 13,
                            Name = "Child Task 3",
                            StartDate = "02/23/2014",
                            Duration = 0,
                            PercentDone = 40,
                            ResourceId=new List<object>(){2}
                        },
                        new DefaultData()
                        {
                            Id = 13,
                            Name = "Child Task 4",
                            StartDate = "02/23/2014",
                            Duration = 0,
                            PercentDone = 40,
                            ResourceId=new List<object>(){2}
                        }
                    })
                });
                list.Add(new DefaultData()
                {
                    Id = 14,
                    Name = "Parent Task 3",
                    StartDate = "03/14/2014",
                    Duration = 5,
                    PercentDone = 40,
                    Children = (new List<DefaultData>()
                    {
                        new DefaultData()
                        {
                            Id = 15,
                            Name = "Child Task 1",
                            StartDate = "03/02/2014",
                            Duration = 5,
                            PercentDone = 40,
                        },
                        new DefaultData()
                        {
                            Id = 16,
                            Name = "Child Task 2",
                            StartDate = "03/02/2014",
                            Duration = 5,
                            PercentDone = 40,
                        },
                        new DefaultData()
                        {
                            Id = 17,
                            Name = "Child Task 3",
                            StartDate = "03/02/2014",
                            Duration = 5,
                            PercentDone = 40,
                        },
                        new DefaultData()
                        {
                            Id = 18,
                            Name = "Child Task 4",
                            StartDate = "03/02/2014",
                            Duration = 0,
                            PercentDone = 40,
                        }
                    })
                });
                return list;
            }
        }
    }
}
